Index: branches/TerminationCriteria/HeuristicLab.Algorithms.OffspringSelectionGeneticAlgorithm/3.3/OffspringSelectionGeneticAlgorithm.cs
===================================================================
--- branches/TerminationCriteria/HeuristicLab.Algorithms.OffspringSelectionGeneticAlgorithm/3.3/OffspringSelectionGeneticAlgorithm.cs	(revision 12367)
+++ branches/TerminationCriteria/HeuristicLab.Algorithms.OffspringSelectionGeneticAlgorithm/3.3/OffspringSelectionGeneticAlgorithm.cs	(revision 12368)
@@ -230,5 +230,5 @@
     private ComparisonTerminationCriterion<DoubleValue> qualityTerminationCriterion;
     [Storable]
-    private ExecutionTimeTimeTerminationCriterion executionTimeTerminationCriterion;
+    private ExecutionTimeTerminationCriterion executionTimeTerminationCriterion;
     #endregion
 
@@ -355,5 +355,5 @@
       maximumSelectionPressureTerminationCriterion = new ComparisonTerminationCriterion<DoubleValue>("SelectionPressure", "MaximumSelectionPressure", ComparisonType.GreaterOrEqual) { Name = "Maximum Selection Pressure" };
       qualityTerminationCriterion = new ComparisonTerminationCriterion<DoubleValue>() { Name = "Maximum/Minimum Quality" };
-      executionTimeTerminationCriterion = new ExecutionTimeTimeTerminationCriterion(this, TimeSpan.FromMinutes(5)) { Name = "Maximum Execution Time" };
+      executionTimeTerminationCriterion = new ExecutionTimeTerminationCriterion(this, TimeSpan.FromMinutes(5)) { Name = "Maximum Execution Time" };
       ParameterizeTerminationCriteria();
       UpdateTerminationCriteria();
Index: branches/TerminationCriteria/HeuristicLab.Termination/3.3/ComparisonTerminationCriterion.cs
===================================================================
--- branches/TerminationCriteria/HeuristicLab.Termination/3.3/ComparisonTerminationCriterion.cs	(revision 12367)
+++ branches/TerminationCriteria/HeuristicLab.Termination/3.3/ComparisonTerminationCriterion.cs	(revision 12368)
@@ -28,5 +28,5 @@
 
 namespace HeuristicLab.Termination {
-  [Item("ComparisonTerminationCriterion", "An termination criterion which compares to values.")]
+  [Item("ComparisonTerminationCriterion", "An termination criterion which compares two values.")]
   [StorableClass]
   public class ComparisonTerminationCriterion<T> : ThresholdTerminationCriterion<T> where T : class, IItem, IComparable {
Index: branches/TerminationCriteria/HeuristicLab.Termination/3.3/ExecutionTimeTerminationCriterion.cs
===================================================================
--- branches/TerminationCriteria/HeuristicLab.Termination/3.3/ExecutionTimeTerminationCriterion.cs	(revision 12368)
+++ branches/TerminationCriteria/HeuristicLab.Termination/3.3/ExecutionTimeTerminationCriterion.cs	(revision 12368)
@@ -0,0 +1,60 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Termination {
+  [Item("ExecutionTimeTerminationCriterion", "A termination criterion based on execution time of an algorithm.")]
+  [StorableClass]
+  public class ExecutionTimeTerminationCriterion : ThresholdTerminationCriterion<TimeSpanValue> {
+
+    [Storable]
+    private readonly IExecutable executable;
+
+    [StorableConstructor]
+    protected ExecutionTimeTerminationCriterion(bool deserializing) : base(deserializing) { }
+    protected ExecutionTimeTerminationCriterion(ExecutionTimeTerminationCriterion original, Cloner cloner)
+      : base(original, cloner) {
+      executable = cloner.Clone(executable);
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new ExecutionTimeTerminationCriterion(this, cloner);
+    }
+    public ExecutionTimeTerminationCriterion(IExecutable executable)
+      : this(executable, new TimeSpan(0, 10, 0)) { }
+    public ExecutionTimeTerminationCriterion(IExecutable executable, TimeSpan maximumExecutionTime) {
+      this.executable = executable;
+      ThresholdParameter.Value = new TimeSpanValue(maximumExecutionTime);
+
+      Name = "Maximum Execution Time";
+    }
+
+    protected override bool CheckTermination() {
+      var max = ThresholdParameter.Value.Value;
+
+      return executable.ExecutionTime > max;
+    }
+  }
+}
Index: branches/TerminationCriteria/HeuristicLab.Termination/3.3/ExecutionTimeTimeTerminationCriterion.cs
===================================================================
--- branches/TerminationCriteria/HeuristicLab.Termination/3.3/ExecutionTimeTimeTerminationCriterion.cs	(revision 12367)
+++ 	(revision )
@@ -1,60 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using HeuristicLab.Common;
-using HeuristicLab.Core;
-using HeuristicLab.Data;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-
-namespace HeuristicLab.Termination {
-  [Item("ExecutionTimeTimeTerminationCriterion", "")]
-  [StorableClass]
-  public class ExecutionTimeTimeTerminationCriterion : ThresholdTerminationCriterion<TimeSpanValue> {
-
-    [Storable]
-    private readonly IExecutable executable;
-
-    [StorableConstructor]
-    protected ExecutionTimeTimeTerminationCriterion(bool deserializing) : base(deserializing) { }
-    protected ExecutionTimeTimeTerminationCriterion(ExecutionTimeTimeTerminationCriterion original, Cloner cloner)
-      : base(original, cloner) {
-      executable = cloner.Clone(executable);
-    }
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new ExecutionTimeTimeTerminationCriterion(this, cloner);
-    }
-    public ExecutionTimeTimeTerminationCriterion(IExecutable executable)
-      : this(executable, new TimeSpan(0, 10, 0)) { }
-    public ExecutionTimeTimeTerminationCriterion(IExecutable executable, TimeSpan maximumExecutionTime) {
-      this.executable = executable;
-      ThresholdParameter.Value = new TimeSpanValue(maximumExecutionTime);
-
-      Name = "Maximum Execution Time";
-    }
-
-    protected override bool CheckTermination() {
-      var max = ThresholdParameter.Value.Value;
-
-      return executable.ExecutionTime > max;
-    }
-  }
-}
Index: branches/TerminationCriteria/HeuristicLab.Termination/3.3/HeuristicLab.Termination-3.3.csproj
===================================================================
--- branches/TerminationCriteria/HeuristicLab.Termination/3.3/HeuristicLab.Termination-3.3.csproj	(revision 12367)
+++ branches/TerminationCriteria/HeuristicLab.Termination/3.3/HeuristicLab.Termination-3.3.csproj	(revision 12368)
@@ -151,5 +151,5 @@
     <Compile Include="ComparisonTerminationCriterion.cs" />
     <Compile Include="MultiTerminationCriterion.cs" />
-    <Compile Include="ExecutionTimeTimeTerminationCriterion.cs" />
+    <Compile Include="ExecutionTimeTerminationCriterion.cs" />
     <Compile Include="TerminationCriterion.cs" />
     <Compile Include="TerminationOperator.cs" />
Index: branches/TerminationCriteria/HeuristicLab.Termination/3.3/ThresholdTerminationCriterion.cs
===================================================================
--- branches/TerminationCriteria/HeuristicLab.Termination/3.3/ThresholdTerminationCriterion.cs	(revision 12367)
+++ branches/TerminationCriteria/HeuristicLab.Termination/3.3/ThresholdTerminationCriterion.cs	(revision 12368)
@@ -27,5 +27,5 @@
 
 namespace HeuristicLab.Termination {
-  [Item("ThreshholdTerminationCriterion", "Basis class for all termination criteria which specifies some form of threshold.")]
+  [Item("ThresholdTerminationCriterion", "Base class for all termination criteria which specifies some threshold.")]
   [StorableClass]
   public abstract class ThresholdTerminationCriterion<T> : TerminationCriterion where T : class, IItem {