Index: /branches/HiveStatistics/sources/HeuristicLab 3.3 Services.sln
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab 3.3 Services.sln	(revision 12393)
+++ /branches/HiveStatistics/sources/HeuristicLab 3.3 Services.sln	(revision 12394)
@@ -1,5 +1,7 @@
 ﻿
 Microsoft Visual Studio Solution File, Format Version 12.00
-# Visual Studio 2012
+# Visual Studio 2013
+VisualStudioVersion = 12.0.31101.0
+MinimumVisualStudioVersion = 10.0.40219.1
 Project("{2150E333-8FDC-42A3-9474-1A3956D46DE8}") = "Solution Items", "Solution Items", "{96396439-A764-4022-A8D2-BE021449B8D1}"
 	ProjectSection(SolutionItems) = preProject
@@ -21,5 +23,5 @@
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Services.Hive-3.3", "HeuristicLab.Services.Hive\3.3\HeuristicLab.Services.Hive-3.3.csproj", "{CF9DA321-AC1B-4FD3-9EC3-67BC6B861BDE}"
 EndProject
-Project("{E24C65DC-7377-472B-9ABA-BC803B73C61A}") = "Hive-3.3", "HeuristicLab.Services.Hive.Web\Hive-3.3\", "{0CA6706D-A569-45DE-A85C-4158891CC1BC}"
+Project("{E24C65DC-7377-472B-9ABA-BC803B73C61A}") = "Hive-3.3(1)", "HeuristicLab.Services.Hive.Web\Hive-3.3\", "{0CA6706D-A569-45DE-A85C-4158891CC1BC}"
 	ProjectSection(WebsiteProperties) = preProject
 		TargetFrameworkMoniker = ".NETFramework,Version%3Dv4.0"
@@ -41,4 +43,5 @@
 		VWDPort = "4505"
 		VWDVirtualPath = "/Hive-3.3"
+		SlnRelativePath = "HeuristicLab.Services.Hive.Web\Hive-3.3\"
 		DefaultWebSiteLanguage = "Visual C#"
 	EndProjectSection
@@ -67,8 +70,12 @@
 	EndProjectSection
 EndProject
+Project("{2150E333-8FDC-42A3-9474-1A3956D46DE8}") = ".nuget", ".nuget", "{FF6E7A4E-9A10-4699-AB11-ECB50A36128B}"
+	ProjectSection(SolutionItems) = preProject
+		.nuget\NuGet.Config = .nuget\NuGet.Config
+		.nuget\NuGet.exe = .nuget\NuGet.exe
+		.nuget\NuGet.targets = .nuget\NuGet.targets
+	EndProjectSection
+EndProject
 Global
-	GlobalSection(TestCaseManagementSettings) = postSolution
-		CategoryFile = HeuristicLab 3.3 Services.vsmdi
-	EndGlobalSection
 	GlobalSection(SolutionConfigurationPlatforms) = preSolution
 		CD_ROM|Any CPU = CD_ROM|Any CPU
@@ -533,3 +540,6 @@
 		HideSolutionNode = FALSE
 	EndGlobalSection
+	GlobalSection(TestCaseManagementSettings) = postSolution
+		CategoryFile = HeuristicLab 3.3 Services.vsmdi
+	EndGlobalSection
 EndGlobal
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.JanitorService/3.3/HeuristicLab.Services.Hive.JanitorService-3.3.csproj
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.JanitorService/3.3/HeuristicLab.Services.Hive.JanitorService-3.3.csproj	(revision 12393)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.JanitorService/3.3/HeuristicLab.Services.Hive.JanitorService-3.3.csproj	(revision 12394)
@@ -113,5 +113,7 @@
   </ItemGroup>
   <ItemGroup>
-    <None Include="app.config" />
+    <None Include="app.config">
+      <SubType>Designer</SubType>
+    </None>
     <None Include="HeuristicLab.snk" />
     <None Include="Properties\AssemblyInfo.cs.frame" />
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.Statistics/3.3/Controllers/AdminDataController.cs
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.Statistics/3.3/Controllers/AdminDataController.cs	(revision 12393)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.Statistics/3.3/Controllers/AdminDataController.cs	(revision 12394)
@@ -2,5 +2,4 @@
 using System.Collections.Generic;
 using System.Linq;
-using System.Web;
 using System.Web.Mvc;
 using HeuristicLab.Services.Hive.DataAccess;
@@ -9,10 +8,8 @@
   public class AdminDataController : Controller {
 
-    public JsonResult UserList()
-    {
-      using (var db = new HiveDataContext(Settings.Default.HeuristicLab_Hive_LinqConnectionString))
-      {
+    public JsonResult UserList() {
+      using (var db = new HiveDataContext(Settings.Default.HeuristicLab_Hive_LinqConnectionString)) {
         var allUsers = (from users in db.DimUsers
-                            select new { users.Name })
+                        select new { users.Name })
                             .ToList();
 
@@ -24,18 +21,20 @@
     }
 
-    public JsonResult TaskStats(DateTime start, DateTime end, string userName=null) {
+    public JsonResult TaskStats(DateTime start, DateTime end, string userName = null) {
       using (var db = new HiveDataContext(Settings.Default.HeuristicLab_Hive_LinqConnectionString)) {
         var taskStats = (from tasks in db.FactTasks
-                        join jobs in db.DimJobs
-                          on tasks.JobId equals jobs.JobId
-                        where tasks.StartTime >= start &&
-                        tasks.EndTime < end &&
-                        (string.IsNullOrEmpty(userName) || jobs.UserName == userName)
-                        select new { tasks.TotalWaitingTime, tasks.TotalTransferTime, tasks.TotalRuntime, tasks.NumCalculationRuns, 
-                          tasks.CoresRequired, tasks.MemoryRequired})
+                         join jobs in db.DimJobs
+                           on tasks.JobId equals jobs.JobId
+                         where tasks.StartTime >= start &&
+                         tasks.EndTime < end &&
+                         (string.IsNullOrEmpty(userName) || jobs.UserName == userName)
+                         select new {
+                           tasks.TotalWaitingTime, tasks.TotalTransferTime, tasks.TotalRuntime, tasks.NumCalculationRuns,
+                           tasks.CoresRequired, tasks.MemoryRequired
+                         })
                           .ToList();
 
         List<KeyValuePair<string, double>> FullStats = new List<KeyValuePair<string, double>>();
-        FullStats.Add(new KeyValuePair<string, double>("Total Waiting Time",taskStats.Sum(w => w.TotalWaitingTime)));
+        FullStats.Add(new KeyValuePair<string, double>("Total Waiting Time", taskStats.Sum(w => w.TotalWaitingTime)));
         FullStats.Add(new KeyValuePair<string, double>("Total Transfer Time", taskStats.Sum(t => t.TotalTransferTime)));
         FullStats.Add(new KeyValuePair<string, double>("Total Runtime", taskStats.Sum(r => r.TotalRuntime)));
@@ -49,17 +48,15 @@
 
     public JsonResult MoreTaskInfo(string taskId) {
-      using (var db = new HiveDataContext(Settings.Default.HeuristicLab_Hive_LinqConnectionString))
-      {
+      using (var db = new HiveDataContext(Settings.Default.HeuristicLab_Hive_LinqConnectionString)) {
         var moreInfo = (from tasks in db.FactTasks
-                         where tasks.TaskId.ToString() == taskId
-                         select new
-                         {
-                           tasks.TotalWaitingTime,
-                           tasks.TotalTransferTime,
-                           tasks.TotalRuntime,
-                           tasks.NumCalculationRuns,
-                           tasks.CoresRequired,
-                           tasks.MemoryRequired,
-                         })
+                        where tasks.TaskId.ToString() == taskId
+                        select new {
+                          tasks.TotalWaitingTime,
+                          tasks.TotalTransferTime,
+                          tasks.TotalRuntime,
+                          tasks.NumCalculationRuns,
+                          tasks.CoresRequired,
+                          tasks.MemoryRequired,
+                        })
                           .ToList();
 
@@ -74,12 +71,10 @@
 
     public JsonResult MoreSlaveInfo(string slaveId, DateTime? start = null, DateTime? end = null) {
-      using (var db = new HiveDataContext(Settings.Default.HeuristicLab_Hive_LinqConnectionString))
-      {
+      using (var db = new HiveDataContext(Settings.Default.HeuristicLab_Hive_LinqConnectionString)) {
         var moreInfo = (from slaves in db.FactClientInfos
                         where slaves.ClientId.ToString() == slaveId &&
                         (!start.HasValue || slaves.Time >= start) &&
                         (!end.HasValue || slaves.Time < end)
-                        select new
-                        {
+                        select new {
                           slaves.Time,
                           slaves.TotalTimeIdle,
@@ -92,5 +87,5 @@
         List<List<KeyValuePair<string, string>>> AllInfo = new List<List<KeyValuePair<string, string>>>();
         List<List<KeyValuePair<string, string>>> DistinctInfo = new List<List<KeyValuePair<string, string>>>();
-        for(var i=0; i < moreInfo.Count; i++) {
+        for (var i = 0; i < moreInfo.Count; i++) {
           List<KeyValuePair<string, string>> newRow = new List<KeyValuePair<string, string>>();
           newRow.Add(new KeyValuePair<string, string>("Time", moreInfo.ElementAt(i).Time.ToShortDateString() + " " + moreInfo.ElementAt(i).Time.ToShortTimeString()));
@@ -112,5 +107,5 @@
             isDistinct = false;
             //Cycles through values of current row and lastRecord
-            for (var j=0; j < row.Count; j++) {
+            for (var j = 0; j < row.Count; j++) {
               //Disregards time field from distinct checks
               if (row.ElementAt(j).Key != "Time") {
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.Statistics/3.3/HeuristicLab.Services.Hive.Statistics-3.3.csproj
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.Statistics/3.3/HeuristicLab.Services.Hive.Statistics-3.3.csproj	(revision 12393)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.Statistics/3.3/HeuristicLab.Services.Hive.Statistics-3.3.csproj	(revision 12394)
@@ -21,4 +21,6 @@
     <IISExpressWindowsAuthentication />
     <IISExpressUseClassicPipelineMode />
+    <SolutionDir Condition="$(SolutionDir) == '' Or $(SolutionDir) == '*Undefined*'">..\..\</SolutionDir>
+    <RestorePackages>true</RestorePackages>
   </PropertyGroup>
   <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">
@@ -126,11 +128,13 @@
     <Content Include="App_Code\ExceptionHelper.cshtml" />
     <None Include="Properties\AssemblyInfo.cs.frame" />
-    <Content Include="Scripts\CollapsingSection.js" />
-    <Content Include="Scripts\jquery.scrollstop.js" />
-    <Content Include="Scripts\SmoothieChartResize.js" />
-    <Content Include="Views\LoginRequired\UserTask.cshtml" />
-    <Content Include="Views\LoginRequired\Admin.cshtml" />
-  </ItemGroup>
-  <ItemGroup>
+    <Content Include="Content\themes\base\accordion.css" />
+    <Content Include="Content\themes\base\all.css" />
+    <Content Include="Content\themes\base\autocomplete.css" />
+    <Content Include="Content\themes\base\base.css" />
+    <Content Include="Content\themes\base\button.css" />
+    <Content Include="Content\themes\base\core.css" />
+    <Content Include="Content\themes\base\datepicker.css" />
+    <Content Include="Content\themes\base\dialog.css" />
+    <Content Include="Content\themes\base\draggable.css" />
     <Content Include="Content\themes\base\images\ui-bg_flat_0_aaaaaa_40x100.png" />
     <Content Include="Content\themes\base\images\ui-bg_flat_75_ffffff_40x100.png" />
@@ -146,49 +150,35 @@
     <Content Include="Content\themes\base\images\ui-icons_888888_256x240.png" />
     <Content Include="Content\themes\base\images\ui-icons_cd0a0a_256x240.png" />
-    <Content Include="Content\themes\base\jquery-ui.css" />
-    <Content Include="Content\themes\base\jquery.ui.accordion.css" />
-    <Content Include="Content\themes\base\jquery.ui.all.css" />
-    <Content Include="Content\themes\base\jquery.ui.autocomplete.css" />
-    <Content Include="Content\themes\base\jquery.ui.base.css" />
-    <Content Include="Content\themes\base\jquery.ui.button.css" />
-    <Content Include="Content\themes\base\jquery.ui.core.css" />
-    <Content Include="Content\themes\base\jquery.ui.datepicker.css" />
-    <Content Include="Content\themes\base\jquery.ui.dialog.css" />
-    <Content Include="Content\themes\base\jquery.ui.progressbar.css" />
-    <Content Include="Content\themes\base\jquery.ui.resizable.css" />
-    <Content Include="Content\themes\base\jquery.ui.selectable.css" />
-    <Content Include="Content\themes\base\jquery.ui.slider.css" />
-    <Content Include="Content\themes\base\jquery.ui.tabs.css" />
-    <Content Include="Content\themes\base\jquery.ui.theme.css" />
-    <Content Include="Content\themes\base\minified\images\ui-bg_flat_0_aaaaaa_40x100.png" />
-    <Content Include="Content\themes\base\minified\images\ui-bg_flat_75_ffffff_40x100.png" />
-    <Content Include="Content\themes\base\minified\images\ui-bg_glass_55_fbf9ee_1x400.png" />
-    <Content Include="Content\themes\base\minified\images\ui-bg_glass_65_ffffff_1x400.png" />
-    <Content Include="Content\themes\base\minified\images\ui-bg_glass_75_dadada_1x400.png" />
-    <Content Include="Content\themes\base\minified\images\ui-bg_glass_75_e6e6e6_1x400.png" />
-    <Content Include="Content\themes\base\minified\images\ui-bg_glass_95_fef1ec_1x400.png" />
-    <Content Include="Content\themes\base\minified\images\ui-bg_highlight-soft_75_cccccc_1x100.png" />
-    <Content Include="Content\themes\base\minified\images\ui-icons_222222_256x240.png" />
-    <Content Include="Content\themes\base\minified\images\ui-icons_2e83ff_256x240.png" />
-    <Content Include="Content\themes\base\minified\images\ui-icons_454545_256x240.png" />
-    <Content Include="Content\themes\base\minified\images\ui-icons_888888_256x240.png" />
-    <Content Include="Content\themes\base\minified\images\ui-icons_cd0a0a_256x240.png" />
-    <Content Include="Content\themes\base\minified\jquery-ui.min.css" />
-    <Content Include="Content\themes\base\minified\jquery.ui.accordion.min.css" />
-    <Content Include="Content\themes\base\minified\jquery.ui.autocomplete.min.css" />
-    <Content Include="Content\themes\base\minified\jquery.ui.button.min.css" />
-    <Content Include="Content\themes\base\minified\jquery.ui.core.min.css" />
-    <Content Include="Content\themes\base\minified\jquery.ui.datepicker.min.css" />
-    <Content Include="Content\themes\base\minified\jquery.ui.dialog.min.css" />
-    <Content Include="Content\themes\base\minified\jquery.ui.progressbar.min.css" />
-    <Content Include="Content\themes\base\minified\jquery.ui.resizable.min.css" />
-    <Content Include="Content\themes\base\minified\jquery.ui.selectable.min.css" />
-    <Content Include="Content\themes\base\minified\jquery.ui.slider.min.css" />
-    <Content Include="Content\themes\base\minified\jquery.ui.tabs.min.css" />
-    <Content Include="Content\themes\base\minified\jquery.ui.theme.min.css" />
+    <Content Include="Content\themes\base\menu.css" />
+    <Content Include="Content\themes\base\progressbar.css" />
+    <Content Include="Content\themes\base\resizable.css" />
+    <Content Include="Content\themes\base\selectable.css" />
+    <Content Include="Content\themes\base\selectmenu.css" />
+    <Content Include="Content\themes\base\slider.css" />
+    <Content Include="Content\themes\base\sortable.css" />
+    <Content Include="Content\themes\base\spinner.css" />
+    <Content Include="Content\themes\base\tabs.css" />
+    <Content Include="Content\themes\base\theme.css" />
+    <Content Include="Content\themes\base\tooltip.css" />
+    <Content Include="Scripts\CollapsingSection.js" />
+    <None Include="Scripts\jquery-2.1.4.intellisense.js" />
+    <Content Include="Scripts\jqPlot\plugins\jqplot.mobile.js" />
+    <Content Include="Scripts\jqPlot\plugins\jqplot.mobile.min.js" />
+    <Content Include="Scripts\jquery-2.1.4.js" />
+    <Content Include="Scripts\jquery-2.1.4.min.js" />
+    <Content Include="Scripts\jquery-ui-1.11.4.js" />
+    <Content Include="Scripts\jquery-ui-1.11.4.min.js" />
+    <Content Include="Scripts\jquery.scrollstop.js" />
+    <None Include="Scripts\jquery.validate-vsdoc.js" />
+    <Content Include="Scripts\jquery.validate.js" />
+    <Content Include="Scripts\jquery.validate.min.js" />
+    <Content Include="Scripts\SmoothieChartResize.js" />
+    <Content Include="Views\LoginRequired\UserTask.cshtml" />
+    <Content Include="Views\LoginRequired\Admin.cshtml" />
+  </ItemGroup>
+  <ItemGroup>
     <Content Include="Content\hl-logo.png" />
     <Content Include="Global.asax" />
     <None Include="Properties\PublishProfiles\HiveStatistics-3.3.pubxml" />
-    <None Include="Scripts\jquery-1.8.2.intellisense.js" />
     <Content Include="HeuristicLab.ico" />
     <Content Include="Scripts\jqPlot\changes.txt" />
@@ -267,18 +257,13 @@
     <Content Include="Scripts\jqPlot\README.txt" />
     <Content Include="Scripts\jqPlot\usage.txt" />
-    <Content Include="Scripts\jquery-1.8.2.js" />
-    <Content Include="Scripts\jquery-1.8.2.min.js" />
-    <None Include="Scripts\jquery.validate-vsdoc.js" />
-    <Content Include="Scripts\jquery-ui-1.8.24.js" />
-    <Content Include="Scripts\jquery-ui-1.8.24.min.js" />
+    <Content Include="Scripts\jquery-2.1.4.min.map" />
     <Content Include="Scripts\jquery.unobtrusive-ajax.js" />
     <Content Include="Scripts\jquery.unobtrusive-ajax.min.js" />
-    <Content Include="Scripts\jquery.validate.js" />
-    <Content Include="Scripts\jquery.validate.min.js" />
     <Content Include="Scripts\jquery.validate.unobtrusive.js" />
     <Content Include="Scripts\jquery.validate.unobtrusive.min.js" />
-    <Content Include="Scripts\modernizr-2.6.2.js" />
     <Content Include="Scripts\smoothie.js" />
-    <Content Include="Web.config" />
+    <Content Include="Web.config">
+      <SubType>Designer</SubType>
+    </Content>
     <Content Include="Web.Debug.config">
       <DependentUpon>Web.config</DependentUpon>
@@ -302,8 +287,11 @@
   <ItemGroup>
     <Folder Include="App_Data\" />
+    <Folder Include="Content\themes\base\minified\images\" />
     <Folder Include="Filters\" />
   </ItemGroup>
   <ItemGroup>
-    <Content Include="packages.config" />
+    <Content Include="packages.config">
+      <SubType>Designer</SubType>
+    </Content>
   </ItemGroup>
   <ItemGroup>
@@ -354,4 +342,11 @@
 call PreBuildEvent.cmd</PreBuildEvent>
   </PropertyGroup>
+  <Import Project="$(SolutionDir)\.nuget\NuGet.targets" Condition="Exists('$(SolutionDir)\.nuget\NuGet.targets')" />
+  <Target Name="EnsureNuGetPackageBuildImports" BeforeTargets="PrepareForBuild">
+    <PropertyGroup>
+      <ErrorText>This project references NuGet package(s) that are missing on this computer. Enable NuGet Package Restore to download them.  For more information, see http://go.microsoft.com/fwlink/?LinkID=322105. The missing file is {0}.</ErrorText>
+    </PropertyGroup>
+    <Error Condition="!Exists('$(SolutionDir)\.nuget\NuGet.targets')" Text="$([System.String]::Format('$(ErrorText)', '$(SolutionDir)\.nuget\NuGet.targets'))" />
+  </Target>
   <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
        Other similar extension points exist, see Microsoft.Common.targets.
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.Statistics/3.3/packages.config
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.Statistics/3.3/packages.config	(revision 12393)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.Statistics/3.3/packages.config	(revision 12394)
@@ -3,7 +3,7 @@
   <package id="Antlr" version="3.4.1.9004" targetFramework="net40" />
   <package id="jqPlot" version="1.0.8" targetFramework="net40" />
-  <package id="jQuery" version="2.1.1" targetFramework="net40" />
-  <package id="jQuery.UI.Combined" version="1.10.4" targetFramework="net40" />
-  <package id="jQuery.Validation" version="1.13.0" targetFramework="net40" />
+  <package id="jQuery" version="2.1.4" targetFramework="net40" />
+  <package id="jQuery.UI.Combined" version="1.11.4" targetFramework="net40" />
+  <package id="jQuery.Validation" version="1.13.1" targetFramework="net40" />
   <package id="Microsoft.AspNet.Mvc" version="4.0.30506.0" targetFramework="net40" />
   <package id="Microsoft.AspNet.Mvc.FixedDisplayModes" version="1.0.0" targetFramework="net40" />